unit frmmain;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  httpdefs, fphttpserver, fpwebfile;

type
  { THTTPServerThread }
  THTTPServerThread = Class(TThread)
  Private
    FServer : TFPHTTPServer;
  Public
    Constructor Create(APort : Word; Const OnRequest : THTTPServerRequestHandler);
    Procedure Execute; override;
    Procedure DoTerminate; override;
    Property Server : TFPHTTPServer Read FServer;
  end;
  { TMainForm }

  TMainForm = class(TForm)
    BStart: TButton;
    BStop: TButton;
    Label1: TLabel;
    MLog: TMemo;
    procedure BStartClick(Sender: TObject);
    procedure BStopClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
    FServer : THTTPServerThread;
    FHandler : TFPCustomFileModule;
    FURL : String;
    Procedure DoHandleRequest(Sender: TObject;
      Var ARequest: TFPHTTPConnectionRequest;
      Var AResponse : TFPHTTPConnectionResponse);
    procedure ShowURL;
  public
    { public declarations }
  end; 

var
  MainForm: TMainForm;

implementation

{ THTTPServerThread }

constructor THTTPServerThread.Create(APort: Word;
  const OnRequest: THTTPServerRequestHandler);
begin
  FServer:=TFPHTTPServer.Create(Nil);
  FServer.Port:=APort;
  FServer.OnRequest:=OnRequest;
  Inherited Create(False);
end;

procedure THTTPServerThread.Execute;
begin
  try
    FServer.Active:=True;
  Finally
    FreeAndNil(FServer);
  end;
end;

procedure THTTPServerThread.DoTerminate;
begin
  inherited DoTerminate;
  FServer.Active:=False;
end;

{$R *.lfm}

{ TMainForm }

procedure TMainForm.FormCreate(Sender: TObject);
begin
  RegisterFileLocation('files','/home/michael/public_html');
  MimeTypesFile:='/etc/mime.types';
  FHandler:=TFPCustomFileModule.CreateNew(Self);
  FHandler.BaseURL:='files/';
end;

procedure TMainForm.BStartClick(Sender: TObject);
begin
  MLog.Lines.Add('Starting server');
  FServer:=THTTPServerThread.Create(8080,@DoHandleRequest);
end;

procedure TMainForm.BStopClick(Sender: TObject);
begin
  MLog.Lines.Add('Stopping server');
  FServer.Terminate;
end;

procedure TMainForm.ShowURL;

begin
  MLog.Lines.Add('Handling request : '+FURL);
end;

procedure TMainForm.DoHandleRequest(Sender: TObject;
  var ARequest: TFPHTTPConnectionRequest;
  var AResponse: TFPHTTPConnectionResponse);
begin
  FURL:=Arequest.URL;
  FServer.Synchronize(@ShowURL);
  FHandler.HandleRequest(ARequest,AResponse);
end;

end                                          .

